#!/usr/bin/python
# -*- coding: iso-8859-1 -*-

##############################################################################################
# Copyright (c) by George Ruinelli 
# License: 	GPL3
# Description:	Basic bible viewer
##############################################################################################

	
import urllib2
import string
import os

import threading
import operator

import data

    
####################################################################################################
class ModuleManager():
    def __init__(self, root):
	#print "ModuleManager"
	self.root = root
	self.threadDownloadTranslation = None
	pass

	  
	  
    def get_module_list(self):
	print "get_module_list"   
	translations = []

	try:
	    u = urllib2.urlopen('http://www.crosswire.org/sword/modules/ModDisp.jsp?modType=Bibles')
	except:
	    print "Failed to access website, do we have an internet connection?"
	    return -1
	
	
	html = u.read()

	lines = html.split("\n")
	#print len(lines)
	
	
	for i in range(0, len(lines)):	  
	    lines[i] = lines[i].strip()
	    pos = lines[i].find("<br><br><b>Language: ")
	    if(pos != -1): #found new language section
		end = lines[i].find(" </b>")
		lang = lines[i][pos+21:end]

		while(lines[i].find("</TABLE>") == -1 ): #end of language section not yet reached		
		    i = i + 1
		    if(lines[i].find("[info]") != -1): #found new translation section
			pos = lines[i+1].find("<TD>")
			pos2 = lines[i+1].find("</TD>")
			name = lines[i+1][pos+4:pos2]	
			
			pos = lines[i+2].find("<TD>")
			pos2 = lines[i+2].find("</TD>")
			nicename = lines[i+2][pos+4:pos2]
			
			#print lang, name, nicename
			
			lang = lang.upper()
			lang_name = lang
			#print len(data.language_names), data.language_names
			for j in range(0, len(data.language_names)):
			    if(data.language_names[j][0] == lang):
				lang_name = data.language_names[j][1]
				break
			
			translations.append([lang, lang_name, name, nicename])			
			i=i+3
		    
		    
		    
	#print translations
	#print data.language_names
	
	translations.sort(key=operator.itemgetter(1, 0, 2))
	
	return translations
	  







    def removeTranslation(self, translation):
	translation = translation.lower()
	print "Remove translation:", translation
	f = data.modules_path + "/" + translation + "/"
	try:
	    print "Removing files.."
	    #os.remove(f + "*")
	    os.remove(f + "nt.bzs")
	    os.remove(f + "nt.bzv")
	    os.remove(f + "nt.bzz")
	    
	    os.remove(f + "ot.bzs")
	    os.remove(f + "ot.bzv")
	    os.remove(f + "ot.bzz")
	except:
	    pass
	  
	f = data.modules_path + "/" + translation + "/"
	try:
	    os.removedirs(f)
	except:
	    pass
	
	f = data.modules_config_path + "/" + translation + ".conf"
	try:
	    os.remove(f)
	except:
	    pass
	print "Done"
      
      
      
      
      
      
      
      

    def installTranslation(self, translation):
	translation = translation.lower()
	print "Install translation:", translation

	try:
	    os.makedirs(data.modules_path + "/" + translation)
	except:
	    pass
	  
	  
	try:
	    os.makedirs(data.modules_config_path)
	except:
	    pass

	
	self.threadDownloadTranslation = MyDownloadThread(translation, self.root)
	self.threadDownloadTranslation.start()

	#print "Download for", translation, "complete" 




    def getDownloadProgress(self):
	return self.threadDownloadTranslation.getDownloadProgress()
















class MyDownloadThread ( threading.Thread ):
    def __init__(self, translation, root): 
	threading.Thread.__init__(self) 
	self.translation = translation
	self.root = root
	self.progress = 0
	print "init MyDownloadThread"
	#self.filename = filename
	
    
    #def run ( self ):
	#print "mythread"





    #def download_module(self, translation, filename):
    def run(self):
	print "Start MyDownloadThread"
	url1 = "http://www.crosswire.org/ftpmirror/pub/sword/raw/modules/texts/ztext/" + self.translation + "/"
	path1 = data.modules_path + "/" + self.translation + "/"

	self.progress = 1

	ret = self.download(url1 + "ot.bzs", path1 + "ot.bzs")
	if(ret == 0 ): self.progress = 2
	else:  #an error occured
	    self.progress = -1
	    return -1

	ret = self.download(url1 + "ot.bzv", path1 + "ot.bzv")
	if(ret == 0 ): self.progress = 3
	else:  #an error occured
	    self.progress = -1
	    return -1

	ret = self.download(url1 + "ot.bzz", path1 + "ot.bzz")
	if(ret == 0 ): self.progress = 4
	else:  #an error occured
	    self.progress = -1
	    return -1
	
	ret = self.download(url1 + "nt.bzs", path1 + "nt.bzs")
	if(ret == 0 ): self.progress = 5
	else:  #an error occured
	    self.progress = -1
	    return -1
	    
	ret = self.download(url1 + "nt.bzv", path1 + "nt.bzv")
	if(ret == 0 ): self.progress = 6
	else:  #an error occured
	    self.progress = -1
	    return -1
	    
	ret = self.download(url1 + "nt.bzz", path1 + "nt.bzz")
	if(ret == 0 ): self.progress = 7
	else:  #an error occured
	    self.progress = -1
	    return -1
	    
	
	ret = self.download("http://www.crosswire.org/ftpmirror/pub/sword/raw/mods.d/" + self.translation + ".conf", data.modules_config_path + "/" + self.translation + ".conf")
	if(ret == 0 ): self.progress = 8
	else:  #an error occured
	    self.progress = -1
	    return -1
	
	
	print "Download of translation complete!"
	
	#self.root.setDownloadComplete()
	
	#try:
	    #u = urllib2.urlopen(url)
	#except:
	    #print "Failed to access website, do we have an internet connection?"
	    #return -1	
	
	
	#d = ""
	#while(1):
	  #x = u.read(4096)
	  #d = d + x
	  #if(not x):
	      #print "!"
	      #break
	  #print "."
	  #self.root.setProgress(len(d))
	
	#d = u.read()
	
	#h = open(f, "w")
	#h.write(d)
	#h.close()
	#return 0




    def download(self, url, localfile):
	print "Downloading", url, "=>", localfile
	try:
	    u = urllib2.urlopen(url)
	except:
	    print "Failed to access website, do we have an internet connection?"
	    return -1	
      
	d = ""
	while(1):
	  x = u.read(4096)
	  d = d + x
	  if(not x):
	      print "!"
	      break
	  print "."
      
      
	try:
	    h = open(localfile, "w")
	    h.write(d)
	except:
	    print "Can not write local file", localfile
	    return -2
	
	h.close()	
	
	return 0
      
      
      
      
    def getDownloadProgress(self):
	return self.progress
