import QtQuick 1.0
import com.nokia.meego 1.0
import com.nokia.extras 1.0 //Device
// import com.nokia.extras 1.1 //PC

Page {
    
//*******************************************************
    
    
    id: bookPage
    tools: toolbar3

    anchors.margins: 10

    

//*******************************************************
    //seems not to work :(
//     function setBookLanguage(bookLanguage){
// 	console.log("Set book language index",  bookLanguage)
// 	dialogBookLanguages.selectedIndex = bookLanguage
// 	console.log(dialogBookLanguages.selectedIndex)
//     }
    

    function filterBooks(){
	var strCompleteBookList = qml_to_python.getListOfBooks()
	var text = searchbox.text.toLowerCase()
// 	console.log(strCompleteBookList)
// 	console.log("----")
	var data = strCompleteBookList.split(";")
	data.pop()
// 	console.log(data)
	if(cbAlphabetic.checked == true){
	    data.sort()
	}
	
// 	console.log(data, data.length)
// 	
	booksModel.clear()
	var n = ""
	var v = ""
	var data2 = ""
	for (var i = 0; i < data.length; i++) {
	    data2 = data[i].split(",")
	    n = data2[0]
	    v = data2[1]
// 	    console.log(i, ":", n, "=>", v)
	    if(n.toLowerCase().search(text) != -1){
// 		console.log("Add:", n, v)
		booksModel.append({"name": n, "value": v});
	    }
        }


// 	console.log("bookPage.filterBooks done")
    }


//*******************************************************
    ListModel {
	id: booksModel
    }
//*******************************************************

    Column {
	id: col
	spacing: 10
	width: parent.width  
	height: parent.height

	  
	TextField {
	    id: searchbox
	    anchors.left: parent.left; 
	    anchors.right: parent.right;
	    height: 50
	    
	    echoMode: TextInput.PasswordEchoOnEdit //Workaround
	    
	    
	    onTextChanged: {
	      console.log(searchbox.text)
		filterBooks()
	    }
	    
	    platformStyle: TextFieldStyle { paddingRight: clearButton.width }
	    Image {
		id: clearButton
		anchors.right: parent.right
		anchors.verticalCenter: parent.verticalCenter
		source: "image://theme/icon-m-input-clear"
		MouseArea {
		    anchors.fill: parent
		    onClicked: {
			inputContext.reset();
			searchbox.text = "";                                        
		    }
		}
	    }
	}

		


	ListView {	  
	    id: listview
	    height: col.height -  searchbox.height - 10
	    width: col.width
	    contentWidth: width
	    contentHeight: height
	    model: booksModel
	    delegate: entry
	    clip: true

	}
	
	ScrollDecorator {
	    flickableItem: listview
	}
	
	
	

	
	
	
	// The delegate for each entry
	Component {
	    id: entry
	    Rectangle {
		property string selectedBook: ""
		id: bookDelegateRectangle
		width: col.width
		height: 60

				
		Rectangle {
		    id: blueline
		    width: col.width 
		    height: 2
		    anchors.horizontalCenter: parent.horizontalCenter
		    anchors.top: parent.top
		    color: "#4c1f0b"
		}
		
		Text {
		    text: "    " + name
		    font.pixelSize: 24
		    verticalAlignment: Text.AlignVCenter
		    height: 58
		}

		
		
			
		MouseArea {
		    anchors.fill: parent
		    onClicked: {			
			console.log(name, value)
			qml_to_python.setBook(value)
			selectedBook = value
			pageStack.pop()
		    }
		}
		
		states: [
		    State {
			name: "selected"
			when: (value==selectedBook)
			PropertyChanges {target: bookDelegateRectangle; color: "#4c1f0b"}
		    }
		]
	    }
	}
	
	
	
    }





//*******************************************************



    ToolBarLayout {
        id: toolbar3
        
	ToolIcon { iconId: "toolbar-back"; onClicked: { pageStack.pop(); }  }
        
        ToolButtonRow {
	    
            ToolButton { 
		id: cbAlphabetic
		text: "ABC"
		checked: false
		onClicked: {
		    if(checked == false)checked = true;
		    else checked = false		
		    filterBooks()
		}
	    }
	    
	    ToolButton { 
		text: "Language"
		onClicked: {
		   onClicked: { 
		      dialogBookLanguages.open(); 		      
		  }
		}
	    }
	    
	    
	}
       
    }
    

    
//*******************************************************
 

    SelectionDialog {
        id: dialogBookLanguages
        titleText: "Select language of books"

        model: ListModel {
	    id: bookLanguagesList
	    //sort alphabethically and matching list in data.py!
	    ListElement { name: "Deutsch" }
	    ListElement { name: "English" }
	    ListElement { name: "Français" } 
	    ListElement { name: "Khmer" } //Khmer
	    ListElement { name: "Suomi" } //Finnish
	    ListElement { name: "Svenska" }
	    ListElement { name: "[More]" } //Keep on last line!
	}

        onAccepted: { 
		var index = dialogBookLanguages.selectedIndex		
		if(index == bookLanguagesList.count-1){
		    moreLanguages.open();
		    return
		}
		qml_to_python.setBookLanguage(index) 
		filterBooks()
	}
    }    
    //*******************************************************



    QueryDialog {
        id: moreLanguages
        icon: "../images/minibible.png"
        titleText: "Add more languages"
        message: "Are you missing the book names in your language? You can help me to add it to MiniBible. Just send me a list of the names of the 66 books in the bible, one entry per line and I will add it."
    } 
    
    
//*******************************************************

    
    

}
