import QtQuick 1.0
import com.nokia.meego 1.0
import "." as MyComponents

Page {
    
  	    
// orientationLock: PageOrientation.LockLandscape
//     orientationLock: PageOrientation.LockPortrait
    
//*******************************************************
    
    
    id: mainPage
    tools: toolbar

    anchors.margins: 10


    Column {
	id: col
	spacing: 10
	width: parent.width  
	height: parent.height
	  
        Flickable {
	    id: flickable
	    contentWidth: bibleText.width
	    contentHeight: bibleText.height
	    width: parent.width  
	    height: parent.height
	    flickableDirection: Flickable.VerticalFlick
	    clip: true

	    TextEdit{
		id: bibleText
		wrapMode: TextEdit.Wrap
		width: col.width
		readOnly:true		
// 		onLinkActivated:{
// 		    console.log("link clicked")
// 		}
            }            
	}
	
// 	PinchArea {
// 	    id: pincharea
//       
// // 	    property double __oldZoom
//       
// 	    anchors.fill: parent
//       
// // 	    function calcZoomDelta(zoom, percent) {
// // 	      return zoom + Math.log(percent)/Math.log(2)
// // 	    }
//       
// 	    onPinchStarted: {
// // 		__oldZoom = map.zoomLevel
// // 		console.log(pinch.scale)
// // 		console.log("onPinchStarted")
// 	    }
//       
// 	    onPinchUpdated: {
// // 	      map.zoomLevel = calcZoomDelta(__oldZoom, pinch.scale)
// // 		console.log(pinch.scale)
// // 		qml_to_python.setFontSizeScale(pinch.scale)
// // 		console.log("onPinchUpdated")
// 	    }
//       
// 	    onPinchFinished: {
// // 	      map.zoomLevel = calcZoomDelta(__oldZoom, pinch.scale)
// // 		console.log(pinch.scale)
// 		qml_to_python.setFontSizeScale(pinch.scale)
// // 		console.log("onPinchFinished")
// 	    }
// 	}
// 	
// 	
// 	MouseArea {
// 	    id: mousearea
//       
// 	    property bool __isPanning: false
// 	    property int __lastY: -1
//       
// 	    anchors.fill : parent
//       
// 	    onPressed: {
// // 		console.log("onPressed")
// 	      __isPanning = true
// 	      __lastY = mouse.y
// 	    }
//       
// 	    onReleased: {
// // 		console.log("onReleased")
// 	      __isPanning = false
// 	    }
//       
// 	    onPositionChanged: {
// // 	      console.log("onPositionChanged")
// 	      if (__isPanning) {
// 		  var dy = mouse.y - __lastY
// 		  flickable.contentY = flickable.contentY - dy
// 		  if(flickable.contentY < 0) flickable.contentY = 0
// 		  if(flickable.contentY > flickable.contentHeight - flickable.height) flickable.contentY = flickable.contentHeight - flickable.height
// 		    
// 		  __lastY = mouse.y
// 	      }
// 	    }
//       
// 	    onCanceled: {
// // 	      console.log("onCanceled")
// 	      __isPanning = false;
// 	    }
// 	}
	
	
	
	
   
	
	Image {
	    id: end_fullscreen
	    anchors.bottom: flickable.bottom
	    anchors.right: flickable.right
	    source: "../images/end_fullscreen.png"
	    visible: false
	    
	    MouseArea {
		anchors.fill: parent
		onClicked: { 
// 		    console.log("quit full screen")
		    appWindow.showStatusBar = true
		    appWindow.showToolBar = true
		    end_fullscreen.visible = false
		}
	    }
	}
	
	
	ScrollDecorator { 
	    flickableItem: flickable 	  
	}
 

    }



//*******************************************************



    ToolBarLayout {
	id: toolbar
	
	ToolButtonRow { 
	  
	    ToolIcon {
                id: bBook
                platformIconId: "icon-m-toolbar-directory"
                onClicked: {
// 		      dialogBooks.open();
		      bookPage.filterBooks()
		      pageStack.push(bookPage) 	
		  }
	    }
                
	    ToolIcon {
                id: bChapter
                platformIconId: "icon-m-toolbar-grid"
                onClicked: {
		      dialogChapters.open();	  

		  }
	    }
                
	    ToolIcon {
                id: bLast
                width: 48
                platformIconId: "toolbar-previous"
                onClicked: {
		    var chapter = dialogChapters.model.get(dialogChapters.selectedIndex).name
		    chapter = chapter*1 - 1
// 		    console.log(chapter) 
		    if(chapter > 0){
			qml_to_python.setChapter(chapter)
			dialogChapters.selectedIndex = dialogChapters.selectedIndex - 1
		    }
		    chapterListSetSelected(chapter)
                }
	    }
                
	    ToolIcon {
                id: bNext
                width: 48
                platformIconId: "toolbar-next"
                onClicked: {
		    var chapter = dialogChapters.model.get(dialogChapters.selectedIndex).name
		    chapter = chapter*1 + 1
// 		    console.log(chapter) 
		    if(chapter <= chaptersList.count){
			qml_to_python.setChapter(chapter)			
			dialogChapters.selectedIndex = dialogChapters.selectedIndex + 1
		    }
		    chapterListSetSelected(chapter)
                }
	    }     
	    
/*	    ToolIcon {
		iconId: "icon-m-toolbar-attachment" ;
		onClicked: DialogBookmarks.open();
	    }	*/    
                
	    ToolIcon {
                id: bFullscreen
                width: 48
                platformIconId: "toolbar-start-fullscreen"
                onClicked: {
		    appWindow.showStatusBar = false
		    appWindow.showToolBar = false
		    end_fullscreen.visible = true
                }
	    }

                
	} 
	    
	ToolIcon {
	    iconId: "toolbar-view-menu" ;
	    onClicked: menuMain.open();
	}
    }
    
    
    
    

//*******************************************************
    
    
    SelectionDialog {
        id: dialogBooks
        titleText: "Select book"

        model: ListModel {
	    id: bookList
        }
        onAccepted: { 
	    var book = dialogBooks.model.get(dialogBooks.selectedIndex).value
// 	    console.log(book) 
	    dialogChapters.selectedIndex = 0
	    qml_to_python.setBook(book)
	}
    }
        
        
        
//     function fillListOfBooks(books){
// // 	console.log("fillListOfBooks", books, books.length)
// // 	var b = books
// // 	console.log(b[20][0])
// 	bookList.clear()
// 	for (var i = 0; i < books.length; i++) {
// // 	    console.log(i)
// // 	    console.log(i, books[i][0], books[i][1])
//             bookList.append({"name": books[i][0], "value": books[i][1]});
//         }
// // 	dialogBooks.selectedIndex = selectedBook-1;
//     }
    
    
    
    function bookListSetSelected(selectedBook){
// 	console.log("bookListSetSelected", bookList.count, selectedBook)
	for (var i = 0; i < bookList.count; i++) {
// 	  console.log(i, bookList.get(i).value)
            if(bookList.get(i).value == selectedBook){
		dialogBooks.selectedIndex = i
		return
	    }
        }
    }
    

    
//*******************************************************
    
        
    SelectionDialog {
        id: dialogChapters
        titleText: "Select chapter"

        model: ListModel {
	    id: chaptersList
	 }

        onAccepted: { 
	    var chapter = dialogChapters.model.get(dialogChapters.selectedIndex).name
	    console.log("Chapter:", chapter) 
// 	    qml_to_python.setChapter(chapter)
	    
	    if(chapter == ""){
		console.log("selected empty chapter entry, revert to previous one")
		//ToDo: set selected index back to previous one
	    }
	    else {
		qml_to_python.setChapter(chapter)
		chapterListSetSelected(chapter)
	    }
	}
    }

    
    
    function fillListOfChapters(chapters){
	chaptersList.clear()
	for (var i = 1; i <= chapters; i++) {
            chaptersList.append({"name" : i+""});
        }
	console.log("chaptersList")
// 	if(chapters < 12){ //Bug fix (list is not shown on the device when there are less than 12 entries): 
// 	    for (var i = chapters; i < 12; i++) chaptersList.append({"name" : ""});
// 	}
    }
    
    
    function chapterListSetSelected(selectedChapter){
      	dialogChapters.selectedIndex = selectedChapter-1;
// 	console.log("  ### chapterListSetSelected", selectedChapter, chaptersList.count)
	
	if(selectedChapter == 1){
	    bLast.enabled = false
	    bLast.platformIconId = "toolbar-previous-dimmed"
	}
	else if(chaptersList.count == 1){
	    bLast.enabled = false
	    bLast.platformIconId = "toolbar-previous-dimmed"
	}
	else{
	    bLast.enabled = true
	    bLast.platformIconId = "toolbar-previous"
	}
	  
	  
	  
	if(selectedChapter == chaptersList.count){
	    bNext.enabled = false
	    bNext.platformIconId = "toolbar-next-dimmed"
	}
	else if(chaptersList.count == 1){
	    bNext.enabled = false
	    bNext.platformIconId = "toolbar-next-dimmed"
	}
	else{
	    bNext.enabled = true
	    bNext.platformIconId = "toolbar-next"
	}
    }
    
    
    
//*******************************************************
    
    function setBibleText(text){
	bibleText.text = text
	flickable.contentY = 0
    }
    
    
//*******************************************************
    
    

    MyComponents.BookPage {
        id: bookPage
    }
    
   
}
