import QtQuick 1.0
import com.nokia.meego 1.0
import com.nokia.extras 1.0 //Device
// import com.nokia.extras 1.1 //PC

Page {
    
  	    
// orientationLock: PageOrientation.LockLandscape
//     orientationLock: PageOrientation.LockPortrait
    
//*******************************************************
    
    
    id: translationPage
    tools: toolbar2

    anchors.margins: 10


//*******************************************************
    function fillListOfInstalledTranslations(translations){
// 	console.log(translations)
	
	installedTranslations.clear()
	for (var i = 0; i < translations.length; i++) {
//             installedTranslations.append({"name": translations[i], "index": i});
            installedTranslations.append({"name": translations[i], "value": translations[i], "language": "" });
        }	
    }
    
    
    function fillListOfRemoteTranslations(translations){
// 	console.log(translations)
	
	remoteTranslations.clear()
	for (var i = 0; i < translations.length; i++) {
            remoteTranslations.append({	"name": translations[i][2], 
					"language": translations[i][1] + " (" + translations[i][0] + ")" });
// 	    console.log("name: ", translations[i][0] + ": " + translations[i][2], ", value: ", translations[i][2], " language: ", translations[i][0] + ": " + translations[i][1])
        }
	
    }

    function setProgress(x){
	console.log(x)
	
    }


//*******************************************************

    ListModel {
        id: installedTranslations        
    }


    ListModel {
        id: remoteTranslations
    }



//*******************************************************

    Rectangle {
	id: container
// 	height: 250
	height: parent.height
	width: parent.width


	// The delegate for each section header
	Component {
	    id: sectionHeading
	    Rectangle {
		width: container.width
		height: childrenRect.height
		color: "#4c1f0b"

		Text {
		    text: " " + section
		    font.bold: true
		    font.pixelSize: 32
		    color: "#FFFFFF"
		}
	    }
	}
	
	// The delegate for each entry
	Component {
	    id: entry
	    Rectangle {
		//property string selectedTranslation: ""
		id: translationDelegateRectangle
		width: container.width
// 		height: childrenRect.height
		height: 60

				
		Rectangle {
		    id: blueline
		    width: container.width 
		    height: 2
		    anchors.horizontalCenter: parent.horizontalCenter
		    anchors.top: parent.top
		    color: "#4c1f0b"
		}

		
		Text {
// 		    id: testbox
		    text: "    " + name
		    font.pixelSize: 24
		    verticalAlignment: Text.AlignVCenter
		    height: 58
		}

		
		
			
		MouseArea {
		    anchors.fill: parent
		    onClicked: {			
			//selectedTranslation = value
			if(translationsList.model == installedTranslations){
	// 			console.log("remove ", name, delegateText.text)
	// 			qml_to_python.removeTranslation(name)
			    dialogRemoveTranslation.translationToBeRemoved = name
			    dialogRemoveTranslation.translationToBeRemovedIndex = index
			    dialogRemoveTranslation.open()
			}
			else{
	// 			console.log("install ", name)
	// 			qml_to_python.installTranslation(name)
			    dialogDownloadTranslation.translationToBeInstalled = name
			    dialogDownloadTranslation.open()
			}
		    }
		}
				
// 		states: [
// 		    State {
// 			name: "selected"
// 			when: (value==selectedTranslation)
// 			PropertyChanges {target: translationDelegateRectangle; color: "#4c1f0b"}
// 		    }
// 		]
	    }
	}
	
	





	ListView {
	    id: translationsList
	    anchors.fill: parent
	    model: installedTranslations
	    delegate: entry

	    section.property: "language"
	    section.criteria: ViewSection.FullString
	    section.delegate: sectionHeading
	}
	
// 	SectionScroller {
// 	    listView: translationsList
// 	}
	
	ScrollDecorator {
	    flickableItem: translationsList
	}
    }





//*******************************************************



    ToolBarLayout {
        id: toolbar2
        ToolIcon { iconId: "toolbar-back"; onClicked: { pageStack.pop(); }  }
        ToolButtonRow {
            ToolButton { 
		id: bInstalled
		text: "Installed"
		checked: true
		onClicked: {
		    if(checked == false){
			checked = true;
			bRemote.checked = false;
			translationsList.model = installedTranslations
		    }
		}
	    }
            ToolButton {
		id: bRemote
		text: "Remote"
		checked: false
		onClicked: {
		    if(checked == false){
// 			console.log(remoteTranslations.count)
			if(remoteTranslations.count == 0)dialogLoadRemoteTranslations.open()
			else{
			    bRemote.checked = true;
			    bInstalled.checked = false
			    translationsList.model = remoteTranslations
			}
		    }
		}
	    }
        }
    }
    

//*******************************************************


    QueryDialog {
        id: dialogLoadRemoteTranslations
        icon: "../images/icon.png"
        titleText: "Load list of remote translations?"
        message: "MiniBible is about to connect to the internet to load the list of available translations. Do you want to continue? You will need to have a working interent connection!\n" + "Warning: If you are living in a persecuted country and do not wish to risk detection, do NOT use this feature! "
	
	acceptButtonText: "Continue"
	rejectButtonText: "Cancel"
	
	onAccepted:{
// 	    console.log("accept")
	    bRemote.checked = true;
	    bInstalled.checked = false
	    dialogLoadRemoteTranslations.close()
	    translationsList.model = remoteTranslations
	    dialogLoadRemoteTranslations.close()
	    bannerBusy.text= "Downloading list of translations..."
	    bannerBusy.show()
	    timerLoadRemoteTranslations.start() //make little delay, so screen gets updated
	}
	
// 	onRejected:{
// 	    console.log("cancel")
// 	}
    } 
    
    
    Timer {
	id: timerLoadRemoteTranslations
	interval: 1000; running: false; repeat: false
	onTriggered: {
	    qml_to_python.fillListOfRemoteTranslations(); 
	    bannerBusy.hide()
	}
    }
       
//*******************************************************

    QueryDialog {
        id: dialogDownloadTranslation
        icon: "../images/icon.png"
        titleText: "Install "+ translationToBeInstalled + "?"
        message: "Do you really want to install this translation?\nIt will take some time!\n"
	
	acceptButtonText: "Continue"
	rejectButtonText: "Cancel"
	
	property string translationToBeInstalled: ""
	
	onAccepted:{   
// 	    dialogDownloadTranslation.close()
	    bannerBusy.text= "Downloading translation..."
	    bannerBusy.show()
	    timerDownloadTranslationProgress.start() //make little delay, so screen gets updated
	    toolbar2.enabled = false
	    translationsList.enabled = false
	    qml_to_python.installTranslation(dialogDownloadTranslation.translationToBeInstalled)
	}
	
	onRejected:{
	    console.log("cancel")
	}
    }     
    
    
        
    
    Timer {
	id: timerDownloadTranslationProgress
	interval: 100; running: false; repeat: true
// 	var progress = 0
	onTriggered: {
	    var progress = qml_to_python.getInstallTranslationProgress()
// 	    console.log("Progress: ", progress)
	    if(progress == 7){
		running = false
		bannerBusy.hide()
		bannerDone.text = "Installed translation " + dialogDownloadTranslation.translationToBeInstalled + ". Please restart MiniBible if it is not visible in the list."
		bannerDone.show()
		toolbar2.enabled = true
		translationsList.enabled = true
// 		pageStack.pop() //workaround as we are not able to refresh list without a SEGFAULT
		installedTranslations.append({"name": dialogDownloadTranslation.translationToBeInstalled, "value": dialogDownloadTranslation.translationToBeInstalled});
		return
	    }
	    else if(progress == -1){ //error occured
		bannerBusy.text = "Installation failed!\nFile not existing or not reachable."
		toolbar2.enabled = true
		translationsList.enabled = true
		return
	    }
	    bannerBusy.text = "Downloading file " + progress + "/7..."
	}
    }


//*******************************************************
    QueryDialog {
        id: dialogRemoveTranslation
        icon: "../images/icon.png"
        titleText: "Remove " + translationToBeRemoved + "?"
        message: "Do you really want to remove this translation?"
	
	acceptButtonText: "Continue"
	rejectButtonText: "Cancel"
	
	property string translationToBeRemoved: ""
	property int translationToBeRemovedIndex: -1
	
	onAccepted:{
// 	    var name = translationsList.model.get(translationsList.selectedIndex).name
// 	    var name = translationsList.model.get(translationsList.selectedIndex).name
	    console.log("remove ", translationToBeRemoved, ", Index: ", translationToBeRemovedIndex)
// 	    bannerBusy.show()
	    qml_to_python.removeTranslation(translationToBeRemoved)
	    bannerBusy.hide()
// 	    bannerDone.show()
// 	    pageStack.pop() //workaround as we are not able to refresh list without a SEGFAULT
	    bannerDone.text = "Removed translation " + translationToBeRemoved
	    bannerDone.show()
// 	    console.log("pop")
// 	    pageStack.push(translationPage)
// 	    console.log("push")
// 	    console.log(translationsList.selectedIndex,     translationsList.model.get(translationsList.selectedIndex).name, translationsList.model.get(translationsList.selectedIndex).index)
	    translationsList.model.remove(translationToBeRemovedIndex)
	}
	
	onRejected:{
	    console.log("cancel")
	}
    }     

//*******************************************************



//     InfoBanner{
//         id: bannerLoadingRemoteTranslations
//         text: "Loading list of available remote translations..."
// //        iconSource: "../images/passwordmaker.png"
// //         timerEnabled: true
// //         timerShowTime: 1000
//     }



    InfoBanner{
        id: bannerDone
        text: "Done"
        iconSource: "../images/icon.png"
//         timerEnabled: true
//         timerShowTime: 1000
    }
    
   

    InfoBanner{
        id: bannerBusy
        text: "Please wait..."
        iconSource: "../images/icon.png"
        timerEnabled: true
        timerShowTime: 1
    }
}
